#ifndef PRNG_H
#define PRNG_H

#include "stdint.h"
#include <random>

class PRNG
{
public:
    PRNG();
    ~PRNG();

    uint32_t getMersenne();
    uint32_t getXoroshiro();
    uint32_t getJkiss32();
    uint32_t getPcg();
    uint32_t getP2Lfsr();

private:

    // Mersenne Twister
    std::mt19937* mersenneTwister;
    std::uniform_int_distribution<uint32_t> distrubution;

    // Xoroshiro 128+
    uint64_t s[2];

    // Jkiss32
    uint32_t _x;
    uint32_t _y;
    uint32_t _z;
    uint32_t _c;
    uint32_t _w;

    // PCG
    uint64_t state;
    uint64_t inc;

    // P2 LFSR

};

#endif // PRNG_H
